\documentclass{article}
\usepackage{qrcode}
\usepackage{fancyhdr}
\usepackage{lipsum}
\usepackage[a4paper,total={170mm,257mm},left=20mm,top=20mm]{geometry}

\newcommand{\matrno}{312345}

\newcommand{\marker}{
    \qrcode[padding,height=1cm,nolink,version=0]{\matrno-\thepage}
}

\renewcommand{\footrulewidth}{0.4pt}
\pagestyle{fancy}
\fancylf{}
\rfoot{\marker}

\begin{document}
    \lipsum
    \newpage
    \lipsum
    \newpage
\end{document}
